<?php 
/**
 * +----------------------------------------------------------------------
 * 根域名列表
 * +----------------------------------------------------------------------
 * 官网：https://www.sw-x.cn
 * +----------------------------------------------------------------------
 * 作者：小黄牛 <1731223728@qq.com>
 * +----------------------------------------------------------------------
 * 开源协议：http://www.apache.org/licenses/LICENSE-2.0
 * +----------------------------------------------------------------------
*/

namespace app\http\Domain;
use app\http\SuperClass\Admin;

class index extends Admin
{
    /**
     * @RequestMapping(route="/domain/index", method="GET", title="根域名列表")
     * @AopBefore(class="box\aop\Auth", function="before")
    */
    public function run() {
        return $this->display('domain/index');
    }

    /**
     * @RequestMapping(route="/domain/index_ajax", method="GET", title="拉取数据")
     * @Param(name="page", value="1", tips="分页")
     * @Param(name="limit", value="10", tips="条数")
     * @AopBefore(class="box\aop\Auth", function="before")
     * @Ioc(class="\x\Db", name="Db")
    */
    public function ajax() {
        $param = \x\Request::get();

        $total = $this->Db->name('domain')->count();
        $list = $this->Db->name('domain')->order('id DESC')->page($param['page'], $param['limit'])->select();

        foreach ($list as $k=>$v) {
            $list[$k]['create_time'] = date('Y-m-d H:i:s', $v['create_time']);
            $list[$k]['update_time'] = $v['update_time'] ? date('Y-m-d H:i:s', $v['update_time']) : '无';
        }
        
        $this->Db->return();
        return $this->returnTable($list, $total);
    }
}



