<?php
/**
 * +----------------------------------------------------------------------
 * 接口父类控制器
 * +----------------------------------------------------------------------
 * 官网：https://www.sw-x.cn
 * +----------------------------------------------------------------------
 * 作者：小黄牛 <1731223728@qq.com>
 * +----------------------------------------------------------------------
 * 开源协议：http://www.apache.org/licenses/LICENSE-2.0
 * +----------------------------------------------------------------------
*/

namespace app\http\SuperClass;
use x\controller\Http;

class Admin extends Http
{
    /**
     * 登录信息
    */
    protected $admin = [];

    public function __construct() {
        if (\x\Session::has('admin')) {
            $admin = \x\Session::get('admin');
            $Db = new \x\Db();
            $this->admin = $Db->name('admin')->where('id', $admin['id'])->find();
            $Db->return();
            $this->assign('admin', $this->admin);
        }
    }

    /**
     * 输出Json到页面
     * @todo 无
     * @author 小黄牛
     * @version v1.1.5 + 2020.07.14
     * @deprecated 暂不启用
     * @global 无
     * @param string $code
     * @param string $msg
     * @param array $data
     * @return void
    */
    public function returnJson($code, $msg='Success', $data=[]) {
        $json = json_encode([
            'code' => "{$code}",
            'msg' => $msg,
            'data' => $data,
        ], JSON_UNESCAPED_UNICODE);
        return $this->fetch($json);
    }

    /**
     * 输出Json到Table
     * @todo 无
     * @author 小黄牛
     * @version v1.1.5 + 2020.07.14
     * @deprecated 暂不启用
     * @global 无
     * @param array $rows
     * @param int $total
     * @return void
    */
    public function returnTable($rows, $total) {
        $json = json_encode([
            'rows' => $rows,
            'total' => $total,
        ], JSON_UNESCAPED_UNICODE);
        return $this->fetch($json);
    }
}